# Phoenix plugin by DeniZka 
# bot must be never banned! 
# last edit by 4epT 02.05.2010
# 
# This source code is licensed under the 
# GNU General Public License, Version 2. 
# See http://www.gnu.org/licenses/gpl.html 

package phoenix; 
use strict; 
use Plugins; 
use Globals; 
use Misc; 
use Log qw(message error); 
use Network; 
use Network::Send; 
use Network::Receive; 
use Utils; 

Plugins::register('Phoenix', 'drop old and born new Login', \&Unload); 

my $hooks = Plugins::addHooks(["packet/login_error", \&checkBanned]); 

my $chooks = Plugins::addHooks(['charSelectScreen', \&bornNew, undef]); 

my $realybanned = 0; 

# Configuration Section 
my $charger = 'plugins/phoenix_charger.txt';
my $story = 'plugins/phoenix_lost.txt';
my %bot = ( 
	'name' => '4-20', #bot name length
	'str'   => 9,  'int'   => 1,    
	'agi'   => 9,  'luk'   => 1, 
	'dex'   => 9,  'vit'   => 1, 
); 

sub Unload { 
	message "Phoenix plugin will unload\n", "macro"; 
	Plugins::delHooks($hooks); 
	Plugins::delHooks($chooks); 
} 

sub checkBanned { 
	my (undef, $args) = @_; 
	my @profiles;
	my @unpacked_data = unpack("x2 C1", $args->{RAW_MSG}); 
	if ($unpacked_data[0] == 6 || $unpacked_data[0] == 4) { 
		Plugins::delHooks($hooks); 
		$realybanned = 1; 
		message "Seems you Banned! Phoenix will reborn!\n"; 
		message "Saving your previous bot login..\n"; 
		if (open(F, ">> $story")) { 
			print F '['.getFormattedDate(int(time)).'] '.$config{"username"}.'='.$config{"password"}."\n"; 
			close(F); 
		} 
		
		#read login base
		if (!open(F, "< $charger")){return};
		{	local($/);
			@profiles = split(/\n/, <F>);
		}
		close F;
		my $count = scalar(@profiles) - 1;
		if ($count == -1) {
			error "Your logins charger is empty. Nothing to do.\n";		
			return
			# or die will better ?
		}
		
		#set new login
		my @newlogin = split(/=/, $profiles[0]);
		Commands::run("conf username $newlogin[0]"); 
		Commands::run("conf password $newlogin[1]"); 
		Commands::run("conf char 0");
		if ($count == 0){
			message "Warning!\nUpdate your logins charger.\nThere're no more logins left!\n";
		} elsif ($count == 1) {
			message "Last login left in your charger!\n";
		} else {
			message " $count logins left in your charger\n"
		}
	
		#record base back
		splice (@profiles, 0, 1);
		open(F, "> $charger");
		print F join("\n", @profiles);
		close F;
		
		Commands::run("relog"); 
	} 
} 

sub bornNew { 
	if ($realybanned) { 
		my (undef, $args) = @_; 
		Plugins::delHooks($chooks); 
		my @Lstr = split(/-/, $bot{name}); 
		$chooks = Plugins::addHooks(['charSelectScreen', \&loginNew, undef]); 
		Misc::createCharacter( 
			0, vocalString(rand($Lstr[1] - $Lstr[0] + 1) + $Lstr[0]), 
			$bot{str}, $bot{agi}, $bot{vit}, $bot{int}, $bot{dex}, $bot{luk}, 
			int(rand(5)) + 1, int(rand(15))+5 
		);    
		$timeout{'charlogin'}{'time'} = time; 
		$args->{return} = 2; 
		$realybanned = 0 
	} 
} 

sub loginNew { 
	my (undef, $args) = @_; 
	$messageSender->sendCharLogin(0); 
	$timeout{'charlogin'}{'time'} = time; 
	$args->{return} = 1; 
	Plugins::delHooks($chooks); 
} 
1;